

/**
 * 初始化
 * @param ArtCode
 * @param sGuide 显示引导层
 * @param fStep 第一步引导
 * @constructor
 */
function ImageView(viewId, showPicPath, imageServer,showPicPathmd5, ext,sGuide,fStep) {
    this.viewer = null;
    this.viewerId = viewId;
    this.ImageServer = imageServer;
    this.ext = ext;
    this.showPicPath = '';
    this.showPicPathmd5 = showPicPathmd5;
    if (typeof showPicPath == "string") {
        this.showPicPath = showPicPath;
    }
    this.sGuide = sGuide;
    this.fStep = fStep;
    this.onerror = '';
    this.Init();
}

/**
 * 设置选项
 * @param key
 * @param value
 * @constructor
 */
ImageView.prototype.SetOption = function (key, value) {
    this[key] = value;
}
/**
 * 更换artcode 和图片
 * @param artCode
 * @constructor
 */
ImageView.prototype.SetArt = function (showPicPath) {
    if (!showPicPath) {
        return false;
    }
    this.ArtCode = showPicPath;
//    this.getImageOption();
}
/**
 * 初始化图片
 * @constructor
 */
ImageView.prototype.Init = function () {
    this.getImageOption();
}
/**
 * 获取算法配置和服务端token
 */
ImageView.prototype.getImageOption = function () {
    var _self = this;
//    var msg = document.getElementById("errorMsg").value;
    var msg = '';
    var errPop = document.querySelector(".errPop");
    var defIcon = document.querySelector(".defaultIcon");
    var errIcon = document.querySelector(".errIcon");
    var defTips = document.querySelector(".defTips");
    if(msg!==''){
        defTips.innerHTML = msg;
        errPop.style.display = 'block';
        return false;
    }
    $.ajax({
        type: "GET",
        dataType: "jsonp",
        jsonp: "callback",
        url: this.ImageServer + "/show/getImageOption",
        data: "showPic=" + this.showPicPath,
        success: function (data) {
            if(data.code == 0) {
                _self.token = data.data.aesStr;
                //0-deepzoom未处理  1-deepzoom处理完成 2-deepzoom已经处理 但是失败了 10-清空
                _self.type = data.data.type;
                if(_self.type!==1){
                    switch (_self.type) {
                        //0-deepzoom未处理  2-deepzoom已经处理 但是失败了 10-清空
                        case 0 :
                            msg = '精拍大图赶路上传中，稍后查看';
                            break;
                        default :
                            defIcon.style.display = 'none';
                            errIcon.style.display = 'block';
                            msg = '图片看不到？请等待，小雅着急修复中';
                            break;
                    }
                    defTips.innerHTML = msg;
                    errPop.style.display = 'block';
                    return false;
                }
                _self.viewerW = data.data.w;
                _self.viewerH = data.data.h;
                _self.setServerToken(_self.token);
                _self.setViewer(_self.viewerW, _self.viewerH);
            }else{
                defTips.innerHTML = '精拍大图赶路上传中，稍后查看';
                // defTips.innerHTML = data.msg||'未知错误';
            }

        }
    });
}


ImageView.prototype.setServerToken = function (serverToken) {
    function setCookie(c_name, value, expiredays) {
        delcookie(c_name);
        var exdate = new Date();
        exdate.setDate(exdate.getDate() + expiredays);
        document.cookie = c_name + "=" + escape(value) + ((expiredays == null) ? "" : ";expires=" + exdate.toGMTString() + ";path=/;domain=.artron.net");
    }

    function delcookie(name) {
        var exp = new Date();
        exp.setTime(exp.getTime() - 1);
        var cval = getCookie(name);
        if (cval != null) document.cookie = name + "=" + cval + ";expires=" + exp.toGMTString();
    }

    function getCookie(name) {
        var arr = document.cookie.match(new RegExp("(^| )" + name + "=([^;]*)(;|$)"));
        if (arr != null) {
            return (arr[2]);
        } else {
            return "";
        }
    }

    if (serverToken) {
        setCookie('token', serverToken, 1)
    }
};

ImageView.prototype.setViewer = function(w,h)
{
    var _self = this;
    var viewer = OpenSeadragon({
        id: this.viewerId,              //id
        placeholderFillStyle:'#121621', //初始化时，图片未载入现实的样式，默认是白色
        showZoomControl:false,
        showFullPageControl:false,
        pixelsPerWheelLine:80, //移动速度
        homeButton:"gohome",                   //恢复默认
        minZoomImageRatio: 1,               //初始化图片后允许缩放最小比例
        visibilityRatio : 1,                //图片在框内的最小比例100%
        constrainDuringPan : true,          //管拖拽,true就不能拖拽了
        immediateRender : true,             //建议将移动设备的设置更改为true
        iOSDevice:true,
        tileSources:   {
            Image: {
                xmlns:    "http://schemas.microsoft.com/deepzoom/2008", //指令集
                Url:      this.ImageServer+"/show/images/"+this.showPicPathmd5+"/",           //图片库地址
                Format:   this.ext,          //切片格式
                Overlap:  "1",            //相邻图片重合的像素
                TileSize: "256",          //单个切片（正方形）的边长
                Size: {                   //图片总大小
                    Height: h,
                    Width:  w
                }
            }
        },
        gestureSettingsMouse: {
            clickToZoom: false
        }
    });
    if(this.sGuide){
        setTimeout(function () {
            _self.fStep.style.display = 'block';
        },500);
    }
}